Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs	(revision 2504)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Manager/PluginValidator.cs	(revision 2504)
@@ -0,0 +1,330 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.Reflection;
+using System.IO;
+using System.Diagnostics;
+using System.Linq;
+
+
+namespace HeuristicLab.PluginInfrastructure.Manager {
+  /// <summary>
+  /// Discovers all installed plugins in the plugin directory. Checks correctness of plugin meta-data and if
+  /// all plugin files are available and checks plugin dependencies. 
+  /// </summary>
+  internal sealed class PluginValidator : MarshalByRefObject {
+    internal event EventHandler<PluginInfrastructureEventArgs> PluginLoaded;
+
+    private Dictionary<PluginDescription, List<string>> pluginDependencies;
+
+    private List<ApplicationDescription> applications;
+    internal IEnumerable<ApplicationDescription> Applications {
+      get {
+        if (string.IsNullOrEmpty(PluginDir)) throw new InvalidOperationException("PluginDir is not set.");
+        if (applications == null) DiscoverAndCheckPlugins();
+        return applications;
+      }
+    }
+
+    private IEnumerable<PluginDescription> plugins;
+    internal IEnumerable<PluginDescription> Plugins {
+      get {
+        if (string.IsNullOrEmpty(PluginDir)) throw new InvalidOperationException("PluginDir is not set.");
+        if (plugins == null) DiscoverAndCheckPlugins();
+        return plugins;
+      }
+    }
+
+    internal string PluginDir { get; set; }
+
+    internal PluginValidator() {
+      this.pluginDependencies = new Dictionary<PluginDescription, List<string>>();
+
+      // ReflectionOnlyAssemblyResolveEvent must be handled because we load assemblies from the plugin path 
+      // (which is not listed in the default assembly lookup locations)
+      AppDomain.CurrentDomain.ReflectionOnlyAssemblyResolve += ReflectionOnlyAssemblyResolveEventHandler;
+    }
+
+    private Assembly ReflectionOnlyAssemblyResolveEventHandler(object sender, ResolveEventArgs args) {
+      return Assembly.ReflectionOnlyLoad(args.Name);
+    }
+
+
+    /// <summary>
+    /// Init first clears all internal datastructures (including plugin lists)
+    /// 1. All assemblies in the plugins directory are loaded into the reflection only context.
+    /// 2. The validator checks if all necessary files for each plugin are available.
+    /// 3. The validator builds the tree of plugin descriptions (dependencies)
+    /// 4. The validator checks if all dependencies for each plugin are ok.
+    /// 5. All plugins for which there are no dependencies missing are loaded into the execution context.
+    /// 6. Each loaded plugin (all assemblies) is searched for a types that implement IPlugin
+    ///    then one instance of each IPlugin type is activated and the OnLoad hook is called.
+    /// 7. All types implementing IApplication are discovered
+    /// </summary>
+    internal void DiscoverAndCheckPlugins() {
+      pluginDependencies.Clear();
+
+      IEnumerable<Assembly> reflectionOnlyAssemblies = ReflectionOnlyLoadDlls();
+      IEnumerable<PluginDescription> pluginDescriptions = GatherPluginDescriptions(reflectionOnlyAssemblies);
+      CheckPluginFiles(pluginDescriptions);
+
+      // a full list of plugin descriptions is available now we can build the dependency tree
+      BuildDependencyTree(pluginDescriptions);
+
+      // recursively check if all necessary plugins are available and not disabled
+      // disable plugins with missing or disabled dependencies
+      CheckPluginDependencies(pluginDescriptions);
+
+      // mark all plugins as enabled that were not disabled in CheckPluginFiles or CheckPluginDependencies
+      foreach (var desc in pluginDescriptions)
+        if (desc.PluginState != PluginState.Disabled)
+          desc.Enable();
+
+      // test full loading (in contrast to reflection only loading) of plugins
+      // disables plugins that are not loaded correctly
+      LoadPlugins(pluginDescriptions);
+
+      plugins = pluginDescriptions;
+      DiscoverApplications();
+    }
+
+    private void DiscoverApplications() {
+      applications = new List<ApplicationDescription>();
+
+      foreach (IApplication application in GetApplications()) {
+        Type appType = application.GetType();
+        ApplicationAttribute attr = (from x in appType.GetCustomAttributes(typeof(ApplicationAttribute), false)
+                                     select (ApplicationAttribute)x).Single();
+        ApplicationDescription info = new ApplicationDescription();
+        info.Name = application.Name;
+        info.Version = appType.Assembly.GetName().Version;
+        info.Description = application.Description;
+        info.AutoRestart = attr.RestartOnErrors;
+        info.DeclaringAssemblyName = appType.Assembly.GetName().Name;
+        info.DeclaringTypeName = appType.Namespace + "." + application.GetType().Name;
+
+        applications.Add(info);
+      }
+    }
+
+    private static IEnumerable<IApplication> GetApplications() {
+      return from asm in AppDomain.CurrentDomain.GetAssemblies()
+             from t in asm.GetTypes()
+             where typeof(IApplication).IsAssignableFrom(t) &&
+               !t.IsAbstract && !t.IsInterface && !t.HasElementType
+             select (IApplication)Activator.CreateInstance(t);
+    }
+
+    private IEnumerable<Assembly> ReflectionOnlyLoadDlls() {
+      List<Assembly> assemblies = new List<Assembly>();
+      // try to load each .dll file in the plugin directory into the reflection only context
+      foreach (string filename in Directory.GetFiles(PluginDir, "*.dll")) {
+        try {
+          assemblies.Add(Assembly.ReflectionOnlyLoadFrom(filename));
+        }
+        catch (BadImageFormatException) { } // just ignore the case that the .dll file is not a CLR assembly (e.g. a native dll)
+      }
+      return assemblies;
+    }
+
+    // find all types implementing IPlugin in the reflectionOnlyAssemblies and create a list of plugin descriptions
+    // the dependencies in the plugin descriptions are not yet set correctly because we need to create
+    // the full list of all plugin descriptions first
+    private IEnumerable<PluginDescription> GatherPluginDescriptions(IEnumerable<Assembly> assemblies) {
+      List<PluginDescription> pluginDescriptions = new List<PluginDescription>();
+      foreach (Assembly assembly in assemblies) {
+        // GetExportedTypes throws FileNotFoundException when a referenced assembly
+        // of the current assembly is missing.
+        try {
+          foreach (Type t in assembly.GetExportedTypes()) {
+            // if there is a type that implements IPlugin
+            // use AssemblyQualifiedName to compare the types because we can't directly 
+            // compare ReflectionOnly types and Execution types
+            if (!t.IsAbstract &&
+                t.GetInterfaces().Any(x => x.AssemblyQualifiedName == typeof(IPlugin).AssemblyQualifiedName)) {
+              // fetch the attributes of the IPlugin type
+              pluginDescriptions.Add(GetPluginDescription(t));
+            }
+          }
+        }
+        // ignore exceptions. Just don't yield a plugin description when an exception is thrown
+        catch (FileNotFoundException) {
+        }
+        catch (FileLoadException) {
+        }
+        catch (InvalidPluginException) {
+        }
+      }
+      return pluginDescriptions;
+    }
+
+    /// <summary>
+    /// Extracts plugin information for this type.
+    /// Reads plugin name, list and type of files and dependencies of the plugin. This information is necessary for
+    /// plugin dependency checking before plugin activation.
+    /// </summary>
+    /// <param name="t"></param>
+    private PluginDescription GetPluginDescription(Type pluginType) {
+      // get all attributes of that type
+      IList<CustomAttributeData> attributes = CustomAttributeData.GetCustomAttributes(pluginType);
+      List<string> pluginAssemblies = new List<string>();
+      List<string> pluginDependencies = new List<string>();
+      List<string> pluginFiles = new List<string>();
+      string pluginName = null;
+      // iterate through all custom attributes and search for attributed that we are interested in 
+      foreach (CustomAttributeData attributeData in attributes) {
+        if (IsAttributeDataForType(attributeData, typeof(PluginAttribute))) {
+          pluginName = (string)attributeData.ConstructorArguments[0].Value;
+        } else if (IsAttributeDataForType(attributeData, typeof(PluginDependencyAttribute))) {
+          pluginDependencies.Add((string)attributeData.ConstructorArguments[0].Value);
+        } else if (IsAttributeDataForType(attributeData, typeof(PluginFileAttribute))) {
+          string pluginFileName = (string)attributeData.ConstructorArguments[0].Value;
+          PluginFileType fileType = (PluginFileType)attributeData.ConstructorArguments[1].Value;
+          pluginFiles.Add(Path.Combine(PluginDir, pluginFileName));
+          if (fileType == PluginFileType.Assembly) {
+            pluginAssemblies.Add(Path.Combine(PluginDir, pluginFileName));
+          }
+        }
+      }
+
+      var buildDates = from attr in CustomAttributeData.GetCustomAttributes(pluginType.Assembly)
+                       where IsAttributeDataForType(attr, typeof(AssemblyBuildDateAttribute))
+                       select (string)attr.ConstructorArguments[0].Value;
+
+      // minimal sanity check of the attribute values
+      if (!string.IsNullOrEmpty(pluginName) &&
+          pluginFiles.Count > 0 &&
+          pluginAssemblies.Count > 0 &&
+          buildDates.Count() == 1) {
+        // create a temporary PluginDescription that contains the attribute values
+        PluginDescription info = new PluginDescription();
+        info.Name = pluginName;
+        info.Version = pluginType.Assembly.GetName().Version;
+        info.BuildDate = DateTime.Parse(buildDates.Single(), System.Globalization.CultureInfo.InvariantCulture);
+        info.AddAssemblies(pluginAssemblies);
+        info.AddFiles(pluginFiles);
+
+        this.pluginDependencies[info] = pluginDependencies;
+        return info;
+      } else {
+        throw new InvalidPluginException("Invalid metadata in plugin " + pluginType.ToString());
+      }
+    }
+
+    private static bool IsAttributeDataForType(CustomAttributeData attributeData, Type attributeType) {
+      return attributeData.Constructor.DeclaringType.AssemblyQualifiedName == attributeType.AssemblyQualifiedName;
+    }
+
+    // builds a dependency tree of all plugin descriptions
+    // searches matching plugin descriptions based on the list of dependency names for each plugin
+    // and sets the dependencies in the plugin descriptions
+    private void BuildDependencyTree(IEnumerable<PluginDescription> pluginDescriptions) {
+      foreach (var desc in pluginDescriptions) {
+        foreach (string pluginName in pluginDependencies[desc]) {
+          var matchingDescriptions = pluginDescriptions.Where(x => x.Name == pluginName);
+          if (matchingDescriptions.Count() > 0) {
+            desc.AddDependency(matchingDescriptions.First());
+          } else {
+            // no plugin description that matches the dependency name is available => plugin is disabled
+            desc.Disable();
+            break; // stop processing more dependencies
+          }
+        }
+      }
+    }
+
+    private void CheckPluginDependencies(IEnumerable<PluginDescription> pluginDescriptions) {
+      foreach (PluginDescription pluginDescription in pluginDescriptions.Where(x => x.PluginState != PluginState.Disabled)) {
+        if (IsAnyDependencyDisabled(pluginDescription)) {
+          pluginDescription.Disable();
+        }
+      }
+    }
+
+
+    private bool IsAnyDependencyDisabled(PluginDescription descr) {
+      if (descr.PluginState == PluginState.Disabled) return true;
+      foreach (PluginDescription dependency in descr.Dependencies) {
+        if (IsAnyDependencyDisabled(dependency)) return true;
+      }
+      return false;
+    }
+
+    private void LoadPlugins(IEnumerable<PluginDescription> pluginDescriptions) {
+      // load all loadable plugins (all dependencies available) into the execution context
+      foreach (var desc in PluginDescriptionIterator.IterateInDependencyOrder(pluginDescriptions
+                                                                                .Where(x => x.PluginState != PluginState.Disabled))) {
+        List<Type> types = new List<Type>();
+        foreach (string assembly in desc.Assemblies) {
+          var asm = Assembly.LoadFrom(assembly);
+          foreach (Type t in asm.GetTypes()) {
+            if (typeof(IPlugin).IsAssignableFrom(t)) {
+              types.Add(t);
+            }
+          }
+        }
+
+        foreach (Type pluginType in types) {
+          if (!pluginType.IsAbstract && !pluginType.IsInterface && !pluginType.HasElementType) {
+            IPlugin plugin = (IPlugin)Activator.CreateInstance(pluginType);
+            plugin.OnLoad();
+            OnPluginLoaded(new PluginInfrastructureEventArgs("Plugin loaded", plugin.Name));
+          }
+        }
+        desc.Load();
+      }
+    }
+
+    // checks if all declared plugin files are actually available and disables plugins with missing files
+    private static void CheckPluginFiles(IEnumerable<PluginDescription> pluginDescriptions) {
+      foreach (PluginDescription desc in pluginDescriptions) {
+        if (!CheckPluginFiles(desc)) {
+          desc.Disable();
+        }
+      }
+    }
+
+    private static bool CheckPluginFiles(PluginDescription pluginDescription) {
+      foreach (string filename in pluginDescription.Files) {
+        if (!File.Exists(filename)) {
+          return false;
+        }
+      }
+      return true;
+    }
+
+    internal void OnPluginLoaded(PluginInfrastructureEventArgs e) {
+      if (PluginLoaded != null)
+        PluginLoaded(this, e);
+    }
+
+    /// <summary>
+    /// Initializes the life time service with an infinite lease time.
+    /// </summary>
+    /// <returns><c>null</c>.</returns>
+    public override object InitializeLifetimeService() {
+      return null;
+    }
+  }
+}
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/PluginDescriptionIterator.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/PluginDescriptionIterator.cs	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/PluginDescriptionIterator.cs	(revision 2504)
@@ -24,9 +24,9 @@
 using System.Text;
 
-namespace HeuristicLab.PluginInfrastructure {
-  public static class PluginDescriptionIterator {
-    public static IEnumerable<IPluginDescription> IterateInDependencyOrder(IEnumerable<IPluginDescription> pluginDescriptions) {
+namespace HeuristicLab.PluginInfrastructure.Manager {
+  internal static class PluginDescriptionIterator {
+    internal static IEnumerable<PluginDescription> IterateInDependencyOrder(IEnumerable<PluginDescription> pluginDescriptions) {
       // list to make sure we yield each description only once
-      List<IPluginDescription> yieldedDescriptions = new List<IPluginDescription>();
+      List<PluginDescription> yieldedDescriptions = new List<PluginDescription>();
       foreach (var desc in pluginDescriptions) {
         foreach (var dependency in IterateInDependencyOrder(desc.Dependencies)) {
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/AssemblyInfo.frame
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/AssemblyInfo.frame	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/AssemblyInfo.frame	(revision 2504)
@@ -25,4 +25,5 @@
 using HeuristicLab.PluginInfrastructure;
 using System.Security;
+using System;
 
 // General Information about an assembly is controlled through the following 
@@ -37,5 +38,6 @@
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
-[assembly: AllowPartiallyTrustedCallers]
+[assembly: System.Resources.NeutralResourcesLanguage("en")]
+[assembly: CLSCompliant(true)]
 
 // Setting ComVisible to false makes the types in this assembly not visible 
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Resources.resx
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Resources.resx	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Resources.resx	(revision 2504)
@@ -118,3 +118,19 @@
     <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
   </resheader>
+  <assembly alias="System.Windows.Forms" name="System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089" />
+  <data name="Details" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\Details.gif;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="HeuristicLab" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\HeuristicLab.ico;System.Drawing.Icon, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="LargeIcons" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\LargeIcons.gif;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="List" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\List.gif;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
+  <data name="Logo_white" type="System.Resources.ResXFileRef, System.Windows.Forms">
+    <value>..\Resources\Logo_white.gif;System.Drawing.Bitmap, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a</value>
+  </data>
 </root>
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Settings.settings
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 2503)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 2504)
@@ -6,4 +6,10 @@
       <Value Profile="(Default)">plugins</Value>
     </Setting>
+    <Setting Name="User" Type="System.String" Scope="Application">
+      <Value Profile="(Default)" />
+    </Setting>
+    <Setting Name="Organization" Type="System.String" Scope="Application">
+      <Value Profile="(Default)" />
+    </Setting>
   </Settings>
 </SettingsFile>
Index: branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Starter/MainForm.Designer.cs
===================================================================
--- branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Starter/MainForm.Designer.cs	(revision 2504)
+++ branches/PluginInfrastructure Refactoring/HeuristicLab.PluginInfrastructure/Starter/MainForm.Designer.cs	(revision 2504)
@@ -0,0 +1,199 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.PluginInfrastructure {
+  partial class MainForm {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
+      System.Windows.Forms.ListViewGroup listViewGroup1 = new System.Windows.Forms.ListViewGroup("Plugin Management", System.Windows.Forms.HorizontalAlignment.Left);
+      System.Windows.Forms.ListViewGroup listViewGroup2 = new System.Windows.Forms.ListViewGroup("Applications", System.Windows.Forms.HorizontalAlignment.Left);
+      this.startButton = new System.Windows.Forms.Button();
+      this.largeImageList = new System.Windows.Forms.ImageList(this.components);
+      this.applicationsListView = new System.Windows.Forms.ListView();
+      this.nameColumnHeader = new System.Windows.Forms.ColumnHeader();
+      this.versionColumnHeader = new System.Windows.Forms.ColumnHeader();
+      this.descriptionColumnHeader = new System.Windows.Forms.ColumnHeader();
+      this.smallImageList = new System.Windows.Forms.ImageList(this.components);
+      this.detailsButton = new System.Windows.Forms.Button();
+      this.listButton = new System.Windows.Forms.Button();
+      this.largeIconsButton = new System.Windows.Forms.Button();
+      this.SuspendLayout();
+      // 
+      // startButton
+      // 
+      this.startButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.startButton.Enabled = false;
+      this.startButton.Location = new System.Drawing.Point(579, 511);
+      this.startButton.Name = "startButton";
+      this.startButton.Size = new System.Drawing.Size(75, 23);
+      this.startButton.TabIndex = 1;
+      this.startButton.Text = "Start";
+      this.startButton.UseVisualStyleBackColor = true;
+      this.startButton.Click += new System.EventHandler(this.applicationsListView_ItemActivate);
+      // 
+      // largeImageList
+      // 
+      this.largeImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("largeImageList.ImageStream")));
+      this.largeImageList.TransparentColor = System.Drawing.Color.Transparent;
+      this.largeImageList.Images.SetKeyName(0, "HeuristicLab.ico");
+      // 
+      // applicationsListView
+      // 
+      this.applicationsListView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.applicationsListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.nameColumnHeader,
+            this.versionColumnHeader,
+            this.descriptionColumnHeader});
+      listViewGroup1.Header = "Plugin Management";
+      listViewGroup1.Name = "Plugin Management";
+      listViewGroup2.Header = "Applications";
+      listViewGroup2.Name = "Applications";
+      this.applicationsListView.Groups.AddRange(new System.Windows.Forms.ListViewGroup[] {
+            listViewGroup1,
+            listViewGroup2});
+      this.applicationsListView.LargeImageList = this.largeImageList;
+      this.applicationsListView.Location = new System.Drawing.Point(12, 12);
+      this.applicationsListView.MultiSelect = false;
+      this.applicationsListView.Name = "applicationsListView";
+      this.applicationsListView.ShowItemToolTips = true;
+      this.applicationsListView.Size = new System.Drawing.Size(642, 493);
+      this.applicationsListView.SmallImageList = this.smallImageList;
+      this.applicationsListView.TabIndex = 2;
+      this.applicationsListView.UseCompatibleStateImageBehavior = false;
+      this.applicationsListView.ItemActivate += new System.EventHandler(this.applicationsListView_ItemActivate);
+      this.applicationsListView.ItemSelectionChanged += new System.Windows.Forms.ListViewItemSelectionChangedEventHandler(this.applicationsListBox_SelectedIndexChanged);
+      // 
+      // nameColumnHeader
+      // 
+      this.nameColumnHeader.Text = "Name";
+      this.nameColumnHeader.Width = 125;
+      // 
+      // versionColumnHeader
+      // 
+      this.versionColumnHeader.Text = "Version";
+      // 
+      // descriptionColumnHeader
+      // 
+      this.descriptionColumnHeader.Text = "Description";
+      this.descriptionColumnHeader.Width = 453;
+      // 
+      // smallImageList
+      // 
+      this.smallImageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("smallImageList.ImageStream")));
+      this.smallImageList.TransparentColor = System.Drawing.Color.Transparent;
+      this.smallImageList.Images.SetKeyName(0, "HeuristicLab.ico");
+      // 
+      // detailsButton
+      // 
+      this.detailsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.detailsButton.AutoSize = true;
+      this.detailsButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.Details;
+      this.detailsButton.Location = new System.Drawing.Point(68, 511);
+      this.detailsButton.Name = "detailsButton";
+      this.detailsButton.Size = new System.Drawing.Size(22, 23);
+      this.detailsButton.TabIndex = 5;
+      this.detailsButton.UseVisualStyleBackColor = true;
+      this.detailsButton.Click += new System.EventHandler(this.detailsButton_Click);
+      // 
+      // listButton
+      // 
+      this.listButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.listButton.AutoSize = true;
+      this.listButton.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.listButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.List;
+      this.listButton.Location = new System.Drawing.Point(40, 511);
+      this.listButton.Name = "listButton";
+      this.listButton.Size = new System.Drawing.Size(22, 22);
+      this.listButton.TabIndex = 4;
+      this.listButton.UseVisualStyleBackColor = true;
+      this.listButton.Click += new System.EventHandler(this.listButton_Click);
+      // 
+      // largeIconsButton
+      // 
+      this.largeIconsButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.largeIconsButton.AutoSize = true;
+      this.largeIconsButton.AutoSizeMode = System.Windows.Forms.AutoSizeMode.GrowAndShrink;
+      this.largeIconsButton.Image = HeuristicLab.PluginInfrastructure.Properties.Resources.LargeIcons;
+      this.largeIconsButton.Location = new System.Drawing.Point(12, 511);
+      this.largeIconsButton.Name = "largeIconsButton";
+      this.largeIconsButton.Size = new System.Drawing.Size(22, 22);
+      this.largeIconsButton.TabIndex = 3;
+      this.largeIconsButton.UseVisualStyleBackColor = true;
+      this.largeIconsButton.Click += new System.EventHandler(this.largeIconsButton_Click);
+      // 
+      // MainForm
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.ClientSize = new System.Drawing.Size(666, 546);
+      this.Controls.Add(this.detailsButton);
+      this.Controls.Add(this.listButton);
+      this.Controls.Add(this.largeIconsButton);
+      this.Controls.Add(this.applicationsListView);
+      this.Controls.Add(this.startButton);
+      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
+      this.Name = "MainForm";
+      this.Text = "HeuristicLab Starter";
+      this.FormClosing += new System.Windows.Forms.FormClosingEventHandler(this.MainForm_FormClosing);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button startButton;
+    private System.Windows.Forms.ImageList largeImageList;
+    private System.Windows.Forms.ListView applicationsListView;
+    private System.Windows.Forms.ColumnHeader nameColumnHeader;
+    private System.Windows.Forms.ColumnHeader versionColumnHeader;
+    private System.Windows.Forms.ColumnHeader descriptionColumnHeader;
+    private System.Windows.Forms.Button largeIconsButton;
+    private System.Windows.Forms.Button listButton;
+    private System.Windows.Forms.Button detailsButton;
+    private System.Windows.Forms.ImageList smallImageList;
+  }
+}
